﻿//========================================================================================
// 		"Вывод пополосных PS"
//    		(printPS.jsx)
//
// Версия 0.3
//
//    Скрипт выводит пополосный PS всех открытых в данный момент документов на основе
// заранее настроенного Print Preset. Папка для вывода указывается.
//    Если в документе больше одной страницы, то добавляется суффикс "_pageN",
// где N - номер страницы.
//
// Автор: Андрей Рыжков (ragman)
//
// Дата: 13.10.2006 г.
//
//=========================================================================================

// Начальные установки
myPath = "C:\\\\";
ver = "0.3";
myPrintPresetSelect = "[Default]";

with (app) {

	// Создаем список пресетов
	var myPresets = new Array();
	var mySelectIndexPresets = 0;
	for (myCounter = 0; myCounter < printerPresets.length; myCounter++) {
		myPresets[myCounter] = printerPresets.item(myCounter).name;
		if (myPresets[myCounter] == myPrintPresetSelect) {
			mySelectIndexPresets = myCounter;
		}

	}

	// Создаем диалог
	var myDialog = dialogs.add({name:"СуперПечать PS" + ver});
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Print Preset:"});
				var myDialogPresets = dropdowns.add({stringList:myPresets, selectedIndex:mySelectIndexPresets});
			}
		}
		with (dialogRows.add()) {
			dialogColumns.add().staticTexts.add({staticLabel:"(c) Андрей Рыжков     special946@gmail.com"});
		}
	}
	// Показываем
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	
	// Выбираем папку
	myFolder = Folder.selectDialog();
	if (myFolder == null) {
		alert ("Папка не выбрана!");
		exit();
	}
	
	myPath = myFolder.fsName;
	myCountDocs = documents.length;
		for (di = 0; di < myCountDocs; di ++) {
			myCountPages = documents.item(di).pages.length;
			if (myCountPages == 1) {
				myPSsufix = "";
			} else {
				myPSsufix = "_page%N%";
			}
			documents.item(di).printPreferences.activePrinterPreset = printerPresets.item(myDialogPresets.selectedIndex);
			myFilePath = myPath + "\\\\" + documents.item(di).name + myPSsufix + ".ps";
			myRegExp = new RegExp("%N%", "i");
			for (pi = 0; pi < myCountPages; pi ++) {
				documents.item(di).printPreferences.pageRange = pi+1+"";
				documents.item(di).printPreferences.printFile = myFilePath.replace(myRegExp, pi+1+"");;
				documents.item(di).print(false);
			}
		}
}